Description

`<=>` method of Ruby's standard classes returns nil if it is invoked with an incomparable object. For example, `1 <=> nil` returns nil.

But in Redmine, `<=>` methods in most classes raises an exception.

One of the problems that this can cause is the following indirect error messages when comparisons are made between incomparable

objects.

irb(main):002:0> [IssuePriority.first, nil].sort

Traceback (most recent call last):

        1: from app/models/enumeration.rb:94:in `<=>'

NoMethodError (undefined method `position' for nil:NilClass)

 The attached patch adds a type check and fixes the behavior to return nil.

Before:

irb(main):001:0> IssuePriority.first <=> nil

Traceback (most recent call last):

        1: from app/models/enumeration.rb:94:in `<=>'

NoMethodError (undefined method `position' for nil:NilClass)

irb(main):002:0> [IssuePriority.first, nil].sort

Traceback (most recent call last):

        1: from app/models/enumeration.rb:94:in `<=>'

NoMethodError (undefined method `position' for nil:NilClass)

irb(main):003:0> IssuePriority.first <=> Tracker.last

=> -1

 After:

irb(main):001:0> IssuePriority.first <=> nil

=> nil

irb(main):002:0> [IssuePriority.first, nil].sort

(irb):2:in `sort': comparison of IssuePriority with nil failed (ArgumentError)

irb(main):003:0> IssuePriority.first <=> Tracker.last

=> nil

Related issues:

Related to Redmine - Defect #32704: ActionView::Template::Error (undefined me... Closed

Associated revisions

Revision 22269 - 2023-06-29 16:42 - Go MAEDA

<=> operator should return nil when invoked with an incomparable object (#38772).

Patch by Go MAEDA.

History

#1 - 2023-06-25 06:57 - Go MAEDA

- Related to Defect #32704: ActionView::Template::Error (undefined method `position' for nil:NilClass): added
#2 - 2023-06-26 10:23 - Holger Just

LGTM!

#3 - 2023-06-26 12:04 - Go MAEDA

- Description updated

- Target version set to 5.1.0

#4 - 2023-06-29 16:42 - Go MAEDA

- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch.

Files

add_type_check_in_spaceship_operators.patch 6.28 KB 2023-06-25 Go MAEDA
